TarArchiveOutputStream
Date: 2017-02-08

org.apache.commons.compress.archivers.tar

## Class TarArchiveOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - org.apache.commons.compress.archivers.ArchiveOutputStream
    - - org.apache.commons.compress.archivers.tar.TarArchiveOutputStream

- All Implemented Interfaces:
    java.io.Closeable, java.io.Flushable, java.lang.AutoCloseable

      public class TarArchiveOutputStream
      extends ArchiveOutputStream

  The TarOutputStream writes a UNIX tar archive as an OutputStream. Methods are provided to put entries, and then write their contents by writing to this stream using write().

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `BIGNUMBER_ERROR` Fail if a big number (e.g.
    `static int` | `BIGNUMBER_POSIX` POSIX/PAX extensions are used to store big numbers in the archive.
    `static int` | `BIGNUMBER_STAR` star/GNU tar/BSD tar extensions are used to store big number in the archive.
    `static int` | `LONGFILE_ERROR` Fail if a long file name is required in the archive.
    `static int` | `LONGFILE_GNU` GNU tar extensions are used to store long file names in the archive.
    `static int` | `LONGFILE_POSIX` POSIX/PAX extensions are used to store long file names in the archive.
    `static int` | `LONGFILE_TRUNCATE` Long paths will be truncated in the archive.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TarArchiveOutputStream(java.io.OutputStream os)` Constructor for TarInputStream.
    `TarArchiveOutputStream(java.io.OutputStream os, int blockSize)` Constructor for TarInputStream.
    `TarArchiveOutputStream(java.io.OutputStream os, int blockSize, int recordSize)` Constructor for TarInputStream.
    `TarArchiveOutputStream(java.io.OutputStream os, int blockSize, int recordSize, java.lang.String encoding)` Constructor for TarInputStream.
    `TarArchiveOutputStream(java.io.OutputStream os, int blockSize, java.lang.String encoding)` Constructor for TarInputStream.
    `TarArchiveOutputStream(java.io.OutputStream os, java.lang.String encoding)` Constructor for TarInputStream.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Closes the underlying OutputStream.
    `void` | `closeArchiveEntry()` Close an entry.
    `ArchiveEntry` | `createArchiveEntry(java.io.File inputFile, java.lang.String entryName)` Create an archive entry using the inputFile and entryName provided.
    `void` | `finish()` Ends the TAR archive without closing the underlying OutputStream.
    `void` | `flush()`
    `long` | `getBytesWritten()` Returns the current number of bytes written to this stream.
    `int` | `getCount()` Deprecated.
    `int` | `getRecordSize()` Get the record size being used by this stream's TarBuffer.
    `void` | `putArchiveEntry(ArchiveEntry archiveEntry)` Put an entry on the output stream.
    `void` | `setAddPaxHeadersForNonAsciiNames(boolean b)` Whether to add a PAX extension header for non-ASCII file names.
    `void` | `setBigNumberMode(int bigNumberMode)` Set the big number mode.
    `void` | `setLongFileMode(int longFileMode)` Set the long file mode.
    `void` | `write(byte[] wBuf, int wOffset, int numToWrite)` Writes bytes to the current tar archive entry.

    - ### Methods inherited from class org.apache.commons.compress.archivers.ArchiveOutputStream

      `canWriteEntryData, count, count, write`

    - ### Methods inherited from class java.io.OutputStream

      `write`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### LONGFILE_ERROR

          public static final int LONGFILE_ERROR

      Fail if a long file name is required in the archive.
      See Also:
        Constant Field Values

    - #### LONGFILE_TRUNCATE

          public static final int LONGFILE_TRUNCATE

      Long paths will be truncated in the archive.
      See Also:
        Constant Field Values

    - #### LONGFILE_GNU

          public static final int LONGFILE_GNU

      GNU tar extensions are used to store long file names in the archive.
      See Also:
        Constant Field Values

    - #### LONGFILE_POSIX

          public static final int LONGFILE_POSIX

      POSIX/PAX extensions are used to store long file names in the archive.
      See Also:
        Constant Field Values

    - #### BIGNUMBER_ERROR

          public static final int BIGNUMBER_ERROR

      Fail if a big number (e.g. size > 8GiB) is required in the archive.
      See Also:
        Constant Field Values

    - #### BIGNUMBER_STAR

          public static final int BIGNUMBER_STAR

      star/GNU tar/BSD tar extensions are used to store big number in the archive.
      See Also:
        Constant Field Values

    - #### BIGNUMBER_POSIX

          public static final int BIGNUMBER_POSIX

      POSIX/PAX extensions are used to store big numbers in the archive.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### TarArchiveOutputStream

          public TarArchiveOutputStream(java.io.OutputStream os)

      Constructor for TarInputStream.
      Parameters:
        `os` - the output stream to use

    - #### TarArchiveOutputStream

          public TarArchiveOutputStream(java.io.OutputStream os,
                                java.lang.String encoding)

      Constructor for TarInputStream.
      Parameters:
        `os` - the output stream to use
        `encoding` - name of the encoding to use for file names
      Since:
        1.4

    - #### TarArchiveOutputStream

          public TarArchiveOutputStream(java.io.OutputStream os,
                                int blockSize)

      Constructor for TarInputStream.
      Parameters:
        `os` - the output stream to use
        `blockSize` - the block size to use

    - #### TarArchiveOutputStream

          public TarArchiveOutputStream(java.io.OutputStream os,
                                int blockSize,
                                java.lang.String encoding)

      Constructor for TarInputStream.
      Parameters:
        `os` - the output stream to use
        `blockSize` - the block size to use
        `encoding` - name of the encoding to use for file names
      Since:
        1.4

    - #### TarArchiveOutputStream

          public TarArchiveOutputStream(java.io.OutputStream os,
                                int blockSize,
                                int recordSize)

      Constructor for TarInputStream.
      Parameters:
        `os` - the output stream to use
        `blockSize` - the block size to use
        `recordSize` - the record size to use

    - #### TarArchiveOutputStream

          public TarArchiveOutputStream(java.io.OutputStream os,
                                int blockSize,
                                int recordSize,
                                java.lang.String encoding)

      Constructor for TarInputStream.
      Parameters:
        `os` - the output stream to use
        `blockSize` - the block size to use
        `recordSize` - the record size to use
        `encoding` - name of the encoding to use for file names
      Since:
        1.4

  - ### Method Detail

    - #### setLongFileMode

          public void setLongFileMode(int longFileMode)

      Set the long file mode. This can be LONGFILE_ERROR(0), LONGFILE_TRUNCATE(1) or LONGFILE_GNU(2). This specifies the treatment of long file names (names >= TarConstants.NAMELEN). Default is LONGFILE_ERROR.
      Parameters:
        `longFileMode` - the mode to use

    - #### setBigNumberMode

          public void setBigNumberMode(int bigNumberMode)

      Set the big number mode. This can be BIGNUMBER_ERROR(0), BIGNUMBER_POSIX(1) or BIGNUMBER_STAR(2). This specifies the treatment of big files (sizes > TarConstants.MAXSIZE) and other numeric values to big to fit into a traditional tar header. Default is BIGNUMBER_ERROR.
      Parameters:
        `bigNumberMode` - the mode to use
      Since:
        1.4

    - #### setAddPaxHeadersForNonAsciiNames

          public void setAddPaxHeadersForNonAsciiNames(boolean b)

      Whether to add a PAX extension header for non-ASCII file names.
      Parameters:
        `b` - whether to add a PAX extension header for non-ASCII file names.
      Since:
        1.4

    - #### getCount

          @Deprecated
          public int getCount()

      Deprecated.
      Description copied from class: `ArchiveOutputStream`
      Returns the current number of bytes written to this stream.
      Overrides:
        `getCount` in class `ArchiveOutputStream`
      Returns:
        the number of written bytes

    - #### getBytesWritten

          public long getBytesWritten()

      Description copied from class: `ArchiveOutputStream`
      Returns the current number of bytes written to this stream.
      Overrides:
        `getBytesWritten` in class `ArchiveOutputStream`
      Returns:
        the number of written bytes

    - #### finish

          public void finish()
                      throws java.io.IOException

      Ends the TAR archive without closing the underlying OutputStream. An archive consists of a series of file entries terminated by an end-of-archive entry, which consists of two 512 blocks of zero bytes. POSIX.1 requires two EOF records, like some other implementations.
      Specified by:
        `finish` in class `ArchiveOutputStream`
      Throws:
        `java.io.IOException` - on error

    - #### close

          public void close()
                     throws java.io.IOException

      Closes the underlying OutputStream.
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException` - on error

    - #### getRecordSize

          public int getRecordSize()

      Get the record size being used by this stream's TarBuffer.
      Returns:
        The TarBuffer record size.

    - #### putArchiveEntry

          public void putArchiveEntry(ArchiveEntry archiveEntry)
                               throws java.io.IOException

      Put an entry on the output stream. This writes the entry's header record and positions the output stream for writing the contents of the entry. Once this method is called, the stream is ready for calls to write() to write the entry's contents. Once the contents are written, closeArchiveEntry() MUST be called to ensure that all buffered data is completely written to the output stream.
      Specified by:
        `putArchiveEntry` in class `ArchiveOutputStream`
      Parameters:
        `archiveEntry` - The TarEntry to be written to the archive.
      Throws:
        `java.io.IOException` - on error
        `java.lang.ClassCastException` - if archiveEntry is not an instance of TarArchiveEntry

    - #### closeArchiveEntry

          public void closeArchiveEntry()
                                 throws java.io.IOException

      Close an entry. This method MUST be called for all file entries that contain data. The reason is that we must buffer data written to the stream in order to satisfy the buffer's record based writes. Thus, there may be data fragments still being assembled that must be written to the output stream before this entry is closed and the next entry written.
      Specified by:
        `closeArchiveEntry` in class `ArchiveOutputStream`
      Throws:
        `java.io.IOException` - on error

    - #### write

          public void write(byte[] wBuf,
                   int wOffset,
                   int numToWrite)
                     throws java.io.IOException

      Writes bytes to the current tar archive entry. This method is aware of the current entry and will throw an exception if you attempt to write bytes past the length specified for the current entry. The method is also (painfully) aware of the record buffering required by TarBuffer, and manages buffers that are not a multiple of recordsize in length, including assembling records from small buffers.
      Overrides:
        `write` in class `java.io.OutputStream`
      Parameters:
        `wBuf` - The buffer to write to the archive.
        `wOffset` - The offset in the buffer from which to get bytes.
        `numToWrite` - The number of bytes to write.
      Throws:
        `java.io.IOException` - on error

    - #### flush

          public void flush()
                     throws java.io.IOException

      Specified by:
        `flush` in interface `java.io.Flushable`
      Overrides:
        `flush` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### createArchiveEntry

          public ArchiveEntry createArchiveEntry(java.io.File inputFile,
                                        java.lang.String entryName)
                                          throws java.io.IOException

      Description copied from class: `ArchiveOutputStream`
      Create an archive entry using the inputFile and entryName provided.
      Specified by:
        `createArchiveEntry` in class `ArchiveOutputStream`
      Parameters:
        `inputFile` - the file to create the entry from
        `entryName` - name to use for the entry
      Returns:
        the ArchiveEntry set up with details from the file
      Throws:
        `java.io.IOException` - if an I/O error occurs